##=================================================================
## HTTPDログ解析
## 時間帯別のアクセス集計
## analyze_hourly.awk
##-----------------------------------------------------------------
## 引数のログファイルから、時間帯別のアクセス数の集計を行う
## 出力は、24時間形式で1時間毎に集計
##=================================================================

##=================================================================
## 主処理
##=================================================================

BEGIN {
    FPAT="([^ ]+)|(\"[^\"]+\")|(\[[^\[]+[^\]]+\])"
    total = 0
}

{
    $4=substr($4, 2, length($4)-2)     # 大括弧始まりを除去
    split($4, time, ":") # $4を分割 1:日付, 2:時, 3:分, 4:秒
    hour = time[2]
    freq_of[hour]++
}

END {
    for ( i in freq_of ) {
        if ( ! freq_of[i] ) {
            freq_of[i] = 0
        }
        print i "," freq_of[i]
        total += freq_of[i]
    }
    print "total " total
}

##=================================================================
## 関数定義
##=================================================================
